<template>
  <main>
    <mt-page-title :with-border="false" :with-padding="true">
      <h1 class="has-text-weight-bold is-size-3">Valider ou Débloquer des comptes de mon unité</h1>
    </mt-page-title>
    <mt-box padding="0">
      <b-tabs class="mt-box-onglet">
        <b-tab-item :label="`Comptes à valider (${aValider.fullsize})`">
          <article class="mt-box-content">
            <mt-filtre-categorie
              :fullsize="aValider.fullsize"
              :categories="aValider.corps"
              afficher-total
              @select-all="viderFiltreAValider"
              @select-categorie="filtreCategorieAValider"
            ></mt-filtre-categorie>
            <form>
              <mt-list v-slot="{ item: filtre }" :list="aValider.filtrer">
                <mt-list-item>
                  <div class="columns is-vcentered">
                    <div class="column">
                      <mt-utilisateur :utilisateur="filtre"></mt-utilisateur>
                    </div>
                    <div class="column is-size-8">
                      {{ filtre.telephone }}
                    </div>
                    <div class="column is-size-8">
                      {{ filtre.email }}
                    </div>
                    <div class="column is-narrow">
                      <b-field>
                        <b-checkbox v-model="filtre.enabled" required @input="valider(filtre)"></b-checkbox>
                      </b-field>
                    </div>
                  </div>
                </mt-list-item>
              </mt-list>
            </form>
          </article>
        </b-tab-item>
        <b-tab-item :label="`Comptes à débloquer (${bloquer.fullsize})`">
          <article class="mt-box-content">
            <mt-filtre-categorie
              :fullsize="bloquer.fullsize"
              :categories="bloquer.corps"
              afficher-total
              @select-all="viderFiltreBloquer"
              @select-categorie="filtreCategorieBloquer"
            ></mt-filtre-categorie>
            <form @submit.prevent="submit">
              <mt-list v-slot="{ item: filtre }" :list="bloquer.filtrer">
                <mt-list-item>
                  <div class="columns is-vcentered">
                    <div class="column">
                      <mt-utilisateur :utilisateur="filtre"></mt-utilisateur>
                    </div>
                    <div class="column is-size-8">
                      {{ filtre.telephone }}
                    </div>
                    <div class="column is-size-8">
                      {{ filtre.email }}
                    </div>
                    <div class="column is-narrow">
                      <b-field>
                        <b-checkbox v-model="filtre.accountNonLocked" required @input="debloquer(filtre)"></b-checkbox>
                      </b-field>
                    </div>
                  </div>
                </mt-list-item>
              </mt-list>
            </form>
          </article>
        </b-tab-item>
      </b-tabs>
    </mt-box>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtBox from '~/components/base/box';
import MtFiltreCategorie from '~/components/filtre/filtre-categorie/index';
import MtUtilisateur from '~/components/pax/mt-utilisateur';

export default {
  components: {
    MtUtilisateur,
    MtFiltreCategorie,
    MtPageTitle,
    MtList,
    MtListItem,
    MtBox,
  },
  data() {
    return {
      idCorpsAValider: null,
      idCorpsBloquer: null,
    };
  },
  async asyncData({ $api }) {
    const reqAValider = $api.organisme().utilisateursAValider();
    const reqBloquer = $api.organisme().utilisateursBloques();
    const [aValider, bloquer] = await Promise.all([reqAValider, reqBloquer]);
    return {
      aValider,
      bloquer,
    };
  },
  methods: {
    async refreshAValider() {
      this.aValider = await this.$api.organisme().utilisateursAValider(this.idCorpsAValider);
    },
    filtreCategorieAValider(corps) {
      this.idCorpsAValider = corps.id;
      this.refreshAValider();
    },
    viderFiltreAValider() {
      this.idCorpsAValider = null;
      this.refreshAValider();
    },
    async refreshBloquer() {
      this.bloquer = await this.$api.organisme().utilisateursBloques(this.idCorpsBloquer);
    },
    filtreCategorieBloquer(corps) {
      this.idCorpsBloquer = corps.id;
      this.refreshBloquer();
    },
    viderFiltreBloquer() {
      this.idCorpsBloquer = null;
      this.refreshBloquer();
    },
    async valider(utilisateur) {
      const message = await this.$api.utilisateurs.valider(utilisateur);
      this.$buefy.toast.open({
        message: message.message,
        type: 'is-success',
        duration: 5000,
      });
    },
    async debloquer(utilisateur) {
      const message = await this.$api.utilisateurs.debloquer(utilisateur);
      this.$buefy.toast.open({
        message: message.message,
        type: 'is-success',
        duration: 5000,
      });
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.mt-filter-liste {
  margin-top: 1rem;
}
footer {
  padding: 0.5rem 0;
  margin-bottom: 1rem;
}
</style>
